-- fichier aide_pkg.adb
-- pour qcm machine graphique
-- Guillaume Feneuille novembre 2000
-- dernire modif 20 02 01
-- version 1.3

with Gtk;
use Gtk;
with Gtk.Enums;
use Gtk.Enums;
with Aide_Pkg.Callbacks;
use Aide_Pkg.Callbacks;

package body Aide_Pkg is

   package Aide_Callback is new
      Gtk.Handlers.Callback (Gtk_Window_Record);

   procedure Gtk_New (
         Aide :    out Aide_Access ) is 
   begin
      Aide := new Aide_Record;
      Aide_Pkg.Initialize (Aide);
   end Gtk_New;

   procedure Initialize (
         Aide : access Aide_Record'Class ) is 
      pragma Suppress (All_Checks);
   begin
      Gtk.Window.Initialize (Aide, Window_Toplevel);
      Set_Title (Aide, "Aide");
      Set_Policy (Aide, False, True, False);
      Set_Position (Aide, Win_Pos_None);
      Set_Modal (Aide, False);
      Set_Usize (Aide, 300, 200); --633

      Gtk_New (Aide.Scrolledwindow1);
      Set_Policy (Aide.Scrolledwindow1, Policy_Never, Policy_Never);
      Add (Aide, Aide.Scrolledwindow1);

      Gtk_New (Aide.Viewport1);
      Set_Shadow_Type (Aide.Viewport1, Shadow_In);
      Add (Aide.Scrolledwindow1, Aide.Viewport1);

      Gtk_New_Vbox (Aide.Vbox1, False, 0);
      Add (Aide.Viewport1, Aide.Vbox1);

      Gtk_New (Aide.Scrolledwindow2);
      Set_Policy (Aide.Scrolledwindow2, Policy_Never, Policy_Always);
      Pack_Start (Aide.Vbox1, Aide.Scrolledwindow2, True, True, 0);

      Gtk_New (Aide.Text1);
      Set_Editable (Aide.Text1, False);
      Set_Word_Wrap (Aide.Text1,True);
      Add (Aide.Scrolledwindow2, Aide.Text1);

      Gtk_New (Aide.Quitter_Aide, "Quitter l'aide");
      Set_Relief (Aide.Quitter_Aide, Relief_Normal);
      Pack_Start (Aide.Vbox1, Aide.Quitter_Aide, False, False, 0);
      Button_Callback.Connect
         (Aide.Quitter_Aide, "pressed",
         Button_Callback.To_Marshaller (On_Quitter_Aide_Pressed'access));
      Aide_Callback.Connect
         (Aide, "destroy",
         Aide_Callback.To_Marshaller (On_Aide_Destroy'access));

   end Initialize;

   procedure Creation_Aide is 
   begin
      if Aide = null then
         Gtk_New (Aide);
         Show_All (Aide);
      else
         Delete_Text(Aide.Text1);
      end if;
   end;

end Aide_Pkg;
