-- fichier p_controle.adb
-- pour qcm machine graphique Testada
-- Guillaume Feneuille novembre 2000
-- dernire modif 4 10 01
-- version 1.4

with Ada.Command_Line;
use Ada.Command_Line ;
with Ada.Text_Io;
use Ada.Text_Io ;
with Interfaces.C;
use Interfaces.C;
with Ada.Strings.Unbounded.Text_Io;
use Ada.Strings.Unbounded.Text_Io;
with Ada.Strings.Fixed;
with Ada.Strings.Maps.Constants;
use Ada.Strings.Fixed;
use Ada.Strings.Maps.Constants;

-- Controle est appel par Testada pour valider 
-- l'accs  l'exercice.
-- argument(2) concerne le fichier des questions

with Ada.Exceptions;
use Ada.Exceptions;

package body P_Controle is

   procedure Nom_Utilisateur; 
   procedure C_System (
         Chaine : in     Char_Array ); 
   pragma Import (C,C_System,"system");

   Fichier_Don : File_Type;  

   procedure Controle is 
   begin

      -- contrle de 4 arguments 
      if Argument_Count /= 4
            then
         Raise_Exception (Exc_Non_Autorise'Identity,
            "il faut 4 arguments voyez le fichier lisezmoi");
      end if;

      -- contrle existence du fichier des questions
      begin
         Open(Fichier_Don,In_File,Argument(2));
         Close (Fichier_Don);
      exception
         when Name_Error | Use_Error =>
            Raise_Exception (Exc_Non_Autorise'Identity,
               "fichier des questions inaccessible");
      end;

      -- initialise l'identit Le_Nom (actif  l'IUT notamment)
      if "LIN" = Translate(Argument (4), Upper_Case_Map)
            then
         Nom_Utilisateur; -- sinon Le_Nom vaut "resultat" a priori
      end if;
   end Controle;

   procedure Nom_Utilisateur is 
      Fich : File_Type;  
   begin
      C_System (To_C("whoami  > tempo"));
      Open (Fich, In_File , "tempo");
      Le_Nom := Get_Line (Fich); -- lecture d'un T_Nom
      Delete (Fich);
   end Nom_Utilisateur;

end P_Controle;

