-- fichier qcm.adb
-- lancement du qcm graphique
-- D.Feneuille novembre 2001
-- utilis seulement  l'IUT pour lancer et contrler
-- le logiciel Testada
--
with Interfaces.C, Ada.Text_Io, Ada.Command_Line, Ada.Characters.Handling;
with Ada.Strings.Unbounded.Text_Io;
use Interfaces.C, Ada.Text_Io, Ada.Command_Line, Ada.Characters.Handling;
use Ada.Strings.Unbounded, Ada.Strings.Unbounded.Text_Io;
--
procedure Qcm is
   procedure C_System (
      Chaine : in     Char_Array );
   pragma Import (C,C_System,"system");
   Lanceur : String := Command_Name;
   Fich : File_Type;
   Message : Unbounded_String;
   Nombre_Proces : Positive;

begin
   -- contrle d'un seul argument
   if Argument_Count /= 1
         then
      Put_Line ("ajoutez un argument : le numro du qcm 1, 2, ..,A,..,F");
      return;
   end if;
   -- contrle de l'emplacement du lancement
   if Lanceur /= "/users/prof/fendan/qcm/qcm"
         then
      Put_Line ("lancez la commande /users/prof/fendan/qcm/qcm");
      -- pour viter de lancer qcm aprs l'avoir copi ailleurs
      return;
   end if;
   if (Argument(1)'Length /= 1) or else
         (not Is_Hexadecimal_Digit(Argument(1)(1)))
         then
      Put_Line("l'argument doit tre un chiffre hexadcimal");
      -- contrle de l'argument
      return;
   end if;
   C_System(To_C("ps x | grep '/users/prof/fendan/qcm/qcm' | wc -l > lance"));
   Open (Fich,In_File,"lance");
   Message := Get_Line(Fich);
   Close (Fich);
   C_System(To_C("rm -f lance"));
   Nombre_Proces := Positive'Value(To_String(Message));
   if Nombre_Proces > 3
         then
      Put_Line("le qcm est dj lanc finissez le avant d'en lancer un autre");
      -- un seul qcm  la fois sinon le fichier rsultat est mal structur
      return;
   end if;
   -- lancement du vrai qcm : testada
   C_System(To_C("/users/prof/fendan/algo/executable/testada "
         & Argument(1)
         & " /users/prof/fendan/algo/question/quest"
         & Argument(1)
         & ".txt /users/prof/fendan/algo/rep"
         & Argument(1) & "/ LIN"));
exception
   when others =>
      Put_Line ("Problme de lancement consultez votre revendeur !");
end Qcm;
--
-- Qcm est seulement en excutable pas en lecture
-- ce programme lance la commande testada et ses 4 paramtres
-- Qcm est  placer en fendan/qcm car l'tudiant doit lancer :
-- /users/prof/fendan/qcm/qcm n; commande qui est contrle
--
-- testada est le vrai excutable (non lanc directement  l'IUT)
-- testada est plac  l'IUT dans algo/executable (pas connu des tudiants)
--
-- quest?.txt => fichier de donnes (droit de lecture suivant avancement)
-- rep? est le rpertoire des rponses
-- question et rep? => rpertoires en lecture (resp. en criture)
--
-- algo est un rpertoire seulement en excutable

-- ne pas oublier de mettre testada dans le rpertoire executable
-- avec les droits : chmod o+rx testada  (r?)
-- tous les rpertoires sont au moins  x (videmment)

-- on remarque que testada a 4 arguments :
-- a) le premier est le numro du qcm
-- b) le deuxime est le fichier question : "quest"&argument(1)&".txt"
-- c) le troisime est le rpertoire rponse : "rep"&argument(1)&"/"
-- d) le dernier LIN pour diffrencier du lancement Windows
--
-- synoptique :
--                  algo
--      /            /            \
--  executable   question    rep1, rep2, ....repA,...repF
--        |        / \        / \    / \     / \     / \ 
--     testada    quest?.txt       chaque tudiant
--