-- fichier testada1_pkg-callbacks-outils.adb
-- pour qcm  graphique Testada
-- Guillaume Feneuille novembre 2000
-- dernire modif 16 02 2003 (fvrier DF)
-- version 1.3

with Ada.Characters.Latin_1;
use Ada.Characters.Latin_1;
with Glib;
use Glib;
with Gtk.Text;
use Gtk.Text;
with Gdk.Font;
use Gdk.Font;
with Gdk.Color;
use Gdk.Color;
with P_Controle;
use P_Controle;
with Ada.Strings.Unbounded.Text_Io;
use Ada.Strings.Unbounded.Text_Io;
use Ada.Strings.Unbounded ;
with Ada.Calendar;
use Ada.Calendar ;
with Ada.Numerics.Discrete_Random;
with Aide_Pkg;
use Aide_Pkg;
with Ada.Command_Line;
use Ada.Command_Line;
with Ada.Characters.Handling;
use Ada.Characters.Handling;
with Glib.Convert;
use Glib.Convert;
with Ada.Strings.Unbounded;
use Ada.Strings.Unbounded;


package body Testada1_Pkg.Callbacks.Outils is

   Message : Unbounded_String;  
   Fichier_Text : Ada.Text_Io.File_Type;  

   procedure Lecture (
         Info :    out Bounded_String ); 

   procedure Effacer (
         Fenetre_Texte : Gtk_Text ) is 
   begin
      Freeze(Fenetre_Texte);
      Delete_Text(Fenetre_Texte,0,-1);
      Thaw(Fenetre_Texte);
   end Effacer;

   ----------------
   -- A_La_Ligne --
   ----------------
   procedure A_La_Ligne (
         Fenetre_Text : Gtk_Text;     
         Compt        : Positive := 1 ) is 
   begin
      for Ind in 1.. Compt
            loop
         Insert (Fenetre_Text,Null_Font,Null_Color,Null_Color,
            ' ' & Lf,Gint(2));
      end loop ;
   end A_La_Ligne;

   ------------
   -- Ecrire --
   ------------

   procedure Ecrire (
         Fenetre_Text :        Gtk_Text; 
         Mes          : in     String    ) is 
      Color_Back : Gdk_Color;  
      Color_Fore : Gdk_Color;  
      Mes2       : String (1 .. 200);  
      Long       : Natural;  
   begin
      Mes2 := (others => Space);
      Long := Mes'Length;
      Mes2(1..Long) := Mes;
      
      -- gestion des accents
      Message := To_Unbounded_String(Filename_To_Utf8 (Mes2(1..Long))) ;
      Long := Length (Message);
      Mes2 (1..Long) := To_String (Message);

      Set_Rgb (Color_Back,0,0,16#FFFF#);
      Set_Rgb (Color_Fore,16#FFFF#,16#FFFF#,0);
      Insert (Fenetre_Text,Null_Font,Color_Fore,Color_Back,
         Mes2 ,Gint(Long));
   end Ecrire;

   procedure Suite_Reponse (
         Fenetre_Text : Gtk_Text ) is 
   begin
      if Partir then
         return;
      else
         Creation_Aide;
         Ecrire (Aide.Text1,"Cliquez sur Question Suivante");
      end if;
   end Suite_Reponse;

   procedure Demarrage is 
      L_Enreg        :          T_Enreg;  
      Num            :          P_Dir.Count     := 0;  
      Chemin         : constant String          := Argument (3);  
      Fichier_Sortie :          P_Tex.File_Type;  
   begin
      P_Tex.Open (Fichier_Text, P_Tex.In_File,
         Argument(2));
      Create(Fichier_Dir,Name => Chemin&"direct"&To_String(Le_Nom));
      loop
         exit when P_Tex.End_Of_File (Fichier_Text);

         -- lecture de la question (une ligne de Max_Car au plus)
         Lecture (L_Enreg.Question);

         -- lecture de la rponse attendue V, F
         P_Tex.Get (Fichier_Text,L_Enreg.Reponse);
         L_Enreg.Reponse := To_Upper (L_Enreg.Reponse);
         if (L_Enreg.Reponse /= 'V') and (L_Enreg.Reponse /= 'F')
               then
            raise Exc_Fichier_Question;
         end if;
         P_Tex.Skip_Line (Fichier_Text);

         -- lecture de la "bonne rponse" (une ligne de Max_Car au plus)
         Lecture (L_Enreg.Bonne);

         -- lecture de la "mauvaise rponse" (une ligne de Max_Car au plus)
         Lecture (L_Enreg.Mauvaise);

         Num := Num + 1;
         Write (Fichier_Dir,L_Enreg,Num);
         exit when Positive(Num) = T_Question'Last; -- 20
      end loop;
      if Positive(Num) /= T_Question'Last
            then
         raise Exc_Fichier_Nombre;
      end if;
      P_Tex.Close (Fichier_Text);
      -- juin 2001 mettre le dbut (cf. Note) avec un top ci dessous
      Top_Deb := Clock;
      Creer_Fichier (Fichier_Sortie);
      P_Tex.Put_Line(Fichier_Sortie,"qcm"&Argument(1)&" date : "
         &Image(Datejour));
      P_Tex.Close (Fichier_Sortie);

   exception
      when Exc_Fichier_Question =>
         Creation_Aide;
         Ecrire (Aide.Text1,
            "Il manque V ou F  la question " &
            P_Dir.Count'Image (Num + 1));
         delay 5.0;
         raise;
      when Exc_Fichier_Nombre =>
         Creation_Aide;
         Ecrire (Aide.Text1,
            "Il manque au moins une question");
         delay 5.0;
         raise;
      when others =>
         Creation_Aide;
         Ecrire (Aide.Text1,
            "erreur dans le fichier de donnes" &
            " voir question " & P_Dir.Count'Image (Num + 1));
         delay 5.0;
         raise;
   end Demarrage;

   procedure Repondre (
         Fenetre_Text : Gtk_Text;      
         Message      : Bounded_String ) is 
   begin
      A_La_Ligne(Fenetre_Text,2);
      Ecrire (Fenetre_Text, To_String(Message));
      A_La_Ligne (Fenetre_Text);
   end Repondre;

   procedure Creer_Fichier (
         Fichier_Res :    out P_Tex.File_Type ) is 
      Chemin : constant String := Argument (3);  

   begin
      P_Tex.Open (Fichier_Res,P_Tex.Append_File,Chemin &
         To_String(Le_Nom)&".res");
   exception
      when others =>
         P_Tex.Create(Fichier_Res,P_Tex.Out_File,Chemin&
            To_String(Le_Nom)&".res");
         P_Tex.Put_Line (Fichier_Res, "tudiant : "&To_String(Le_Nom));
   end Creer_Fichier;

   function Datejour return T_Date is 
      Date  : T_Date;  
      Top   : Time    := Clock;  
      Inter : Natural;  
   begin
      Date.Annee := Year(Top);
      Date.Mois := Month(Top);
      Date.Jour:= Day(Top);
      Inter := Integer(Seconds(Top));
      Date.Heure:=Inter/3600;
      Date.Minute:=(Inter/60) rem 60;
      return Date;
   end Datejour;

   function Image (
         Date : T_Date ) 
     return String is 
   begin
      return T_Jour'Image(Date.Jour)& "/" & T_Mois'Image(Date.Mois)
         & "/" & T_Annee'Image(Date.Annee) & "  " &
         T_Heure'Image(Date.Heure) & " h " &
         T_Minute'Image(Date.Minute) & " mn" ;
   end Image;

   procedure Lecture (
         Info :    out Bounded_String ) is 
      Long : Natural;  
      Unb  : Unbounded_String;  
   begin
      Unb := Get_Line(Fichier_Text);
      Long := Length(Unb);
      if Long > Max_Car then
         Info := To_Bounded_String (Slice (Unb,1,Max_Car));
      else
         Info := To_Bounded_String(To_String(Unb));
      end if;
   end Lecture;

   procedure Tirage (
         Nb  : in     Positive; 
         Res :    out Positive  ) is 

      subtype T_Entier is Positive range 1..Nb;
      package P_Alea is new Ada.Numerics.Discrete_Random (T_Entier);
      use P_Alea;
      Gen    : Generator;  
      Hazard : T_Entier;  

      function Indice (
            Valeur_A_Trouver : Positive ) 
        return Positive is 
         Ind      : T_Question := 1;  
         Compteur : Natural    := 0;  
      begin
         loop
            if not Le_Vecteur(Ind).Fait then
               Compteur := Compteur + 1;
            end if;
            exit when Compteur = Valeur_A_Trouver;
            Ind := Ind + 1;
         end loop;
         Le_Vecteur(Ind).Fait := True;
         return Ind;
      end Indice;
   begin
      Reset (Gen);
      Hazard := Random(Gen);
      Res := Indice (Hazard);
   end Tirage ;

end Testada1_Pkg.Callbacks.Outils;
