-- fichier testada1_pkg-callbacks-outils.ads
-- pour qcm graphique Testada
-- utilis par le corps de widget_cb
-- Guillaume Feneuille novembre 2000
-- dernire modif 4/10/01
-- version 1.4

private
package Testada1_Pkg.Callbacks.Outils is

   Exc_Fichier_Question : exception;
   Exc_Fichier_Nombre : exception;

   subtype T_Jour is Integer range 1..31; -- renames Day_Number
   subtype T_Heure is Integer range 0..23;
   subtype T_Minute is Integer range 0..59;
   subtype T_Mois is Integer range 1..12; -- renames Month_Number
   subtype T_Annee is Integer range 1901..2099; -- Year_Number

   type T_Date is 
      record 
         Annee  : T_Annee;  
         Mois   : T_Mois;  
         Jour   : T_Jour;  
         Heure  : T_Heure;  
         Minute : T_Minute;  
      end record; 

   function Datejour return T_Date; 
   -- prise de la date du jour
   function Image (
         Date : T_Date ) 
     return String; 
   -- donne l'anne, le mois, le jour, l'heure et les minutes 
   -- d'une date sous une forme dlaye

   procedure Effacer (
         Fenetre_Texte : Gtk_Text ); 

   procedure Ecrire (
         Fenetre_Text :        Gtk_Text; 
         Mes          : in     String    ); 

   procedure A_La_Ligne (
         Fenetre_Text : Gtk_Text;     
         Compt        : Positive := 1 ); 

   procedure Suite_Reponse (
         Fenetre_Text : Gtk_Text ); 

   procedure Demarrage; 

   procedure Repondre (
         Fenetre_Text : Gtk_Text;      
         Message      : Bounded_String ); 

   procedure Creer_Fichier (
         Fichier_Res :    out P_Tex.File_Type ); 

   procedure Tirage (
         Nb  : in     Positive; 
         Res :    out Positive  ); 

end Testada1_Pkg.Callbacks.Outils ;