-- fichier testada1_pkg-callbacks.adb
-- pour qcm machine graphique Testada
-- Guillaume Feneuille novembre 2000
-- dernire modif 4/10/01 (DF)
-- version 1.4
--
with Gtk.Main;
--
with Testada1_Pkg.Callbacks.Outils;
use Testada1_Pkg.Callbacks.Outils;
with Ada.Strings.Bounded ;
use Ada.Strings.Bounded ;
with P_Controle;
use P_Controle;
with Ada.Strings.Unbounded ;
use Ada.Strings.Unbounded ;
with Ada.Command_Line;
use Ada.Command_Line;
with Interfaces.C;
use Interfaces.C;

with Ada.Direct_Io ;
with Ada.Text_Io;

with Aide_Pkg;
use Aide_Pkg;

package body Testada1_Pkg.Callbacks is

   ----------
   -- Note --
   ----------

   procedure Note is 
      La_Note        :          Integer;  
      Fichier_Sortie :          P_Tex.File_Type;  
      Temps_Pass    :          Duration;  
      Chemin         : constant String          := Argument (3) & To_String
        (Le_Nom) & ".res";  
      procedure C_System (
            Chaine : in     Char_Array ); 
      pragma Import (C,C_System,"system");

   begin
      Creer_Fichier (Fichier_Sortie);
      Top_Fin := Clock;
      Temps_Pass := Top_Fin - Top_Deb;
      P_Tex.Put_Line (Fichier_Sortie,
         "Temps pass (sec) : " & Integer'Image(Integer(Temps_Pass)));
      La_Note := 0;
      for Ind in 1.. T_Question'Last loop
         P_Tex.Put_Line(Fichier_Sortie,"question: "&Positive'Image(Ind)&
            " rponse: " &Le_Vecteur(Ind).Rep);
         if Le_Vecteur(Ind).Rep = 'B'
               then
            La_Note := La_Note + 1;
         elsif Le_Vecteur(Ind).Rep = 'M'
               then
            La_Note := La_Note - 1;
         end if;
      end loop;
      P_Tex.Put_Line(Fichier_Sortie,"note : " & Integer'Image (La_Note));
      P_Tex.Close(Fichier_Sortie);
      P_Dir.Delete(Fichier_Dir);
      --
      if To_String(Le_Nom) /= "resultat"
            then -- unix IUT
         C_System (To_C("chmod o+r " & Chemin));
         -- ncessaire pour ouvrir les droits de lecture
         -- de ceux qui ont un Umask /= 22
      end if;
      --
      Effacer(Testada1.Textequestion);
      Effacer(Testada1.Textereponse);
      Ecrire (Testada1.Textereponse,"votre note : " & Integer'Image (
            La_Note) & "     Vous devez quitter le QCM");
   end Note;

   ------------------------
   -- On_Quitter_Pressed --
   ------------------------

   procedure On_Quitter_Pressed (
         Object : access Gtk_Button_Record'Class ) is 
   begin
      if Partir then
         Gtk.Main.Main_Quit;
      elsif Nb_Question = T_Question'Last
            and then La_Reponse = Non_Permise
            then
         Note;
         Partir:=True;
      else
         Creation_Aide;
         Ecrire (Aide.Text1,
            "Vous devez finir le test avant de pouvoir quitter");
      end if;
   end On_Quitter_Pressed;

   -------------------------
   -- On_Suivante_Pressed --
   -------------------------

   procedure On_Suivante_Pressed (
         Object : access Gtk_Button_Record'Class ) is 
   begin
      if La_Reponse = Attendue
            then
         Creation_Aide;
         Ecrire (Aide.Text1,"appuyez sur Vrai ou Faux ou je ne sais pas");
         return ;
      end if;
      if Partir then
         return;
      end if;
      if Nb_Question = T_Question'Last
            then
         Effacer(Testada1.Textereponse);
         Effacer(Testada1.Textequestion);
         Note;
         Partir:=True;
         return ;
      end if;
      if Nb_Question = T_Question'First
            then
         Demarrage;
      end if;
      -- prparation d'une question au hasard
      -- initialisation de Num puis de Enreg 
      Effacer(Testada1.Textereponse);
      Effacer(Testada1.Textequestion);

      Tirage (T_Question'Last - Nb_Question, Num);
      Read (Fichier_Dir,Enreg,P_Dir.Count(Num));
      --
      Nb_Question := Nb_Question + 1;
      Ecrire (Testada1.Textequestion,To_String(Enreg.Question));
      La_Reponse := Attendue ;
   end On_Suivante_Pressed;

   ---------------------
   -- On_Aide_Pressed --
   ---------------------

   procedure On_Aide_Pressed (
         Object : access Gtk_Button_Record'Class ) is 
   begin
      if Partir then
         return;
      end if;
      if La_Reponse = Attendue
            then
         Creation_Aide;
         Ecrire (Aide.Text1,
            "Cliquez sur Vrai ou Faux ou sur Je ne sais pas");
         return;
      end if;
      if Nb_Question = T_Question'Last
            and then La_Reponse = Non_Permise
            then
         Effacer(Testada1.Textequestion);
         Effacer(Testada1.Textereponse);
         Note;
         Partir:=True;
         return;
      end if;
      if La_Reponse = Non_Permise -- utile?
            then
         Creation_Aide;
         Ecrire (Aide.Text1,"Cliquez sur Question Suivante");
         return;
      end if;
   end On_Aide_Pressed;

   ---------------------
   -- On_Vrai_Pressed --
   ---------------------

   procedure On_Vrai_Pressed (
         Object : access Gtk_Button_Record'Class ) is 
   begin
      if La_Reponse = Attendue
            then
         La_Reponse := Non_Permise;
      else
         Suite_Reponse(Testada1.Textereponse);
         return;
      end if;
      Effacer(Testada1.Textereponse);
      if Enreg.Reponse='V'
            then
         Le_Vecteur(Num).Rep:='B';
         Ecrire (Testada1.Textereponse,
            "Bien, vous avez saisi Vrai et c'est cela :-) :-) "&
            " En effet :");
         A_La_Ligne(Testada1.Textereponse);
         Repondre(Testada1.Textereponse,Enreg.Bonne);
      else
         Le_Vecteur(Num).Rep:='M';
         Ecrire (Testada1.Textereponse,
            "Non, vous avez saisi Vrai mais c'tait Faux :-( :-( "&
            " En effet :");
         A_La_Ligne(Testada1.Textereponse);
         Repondre (Testada1.Textereponse,Enreg.Mauvaise);
      end if;
   end On_Vrai_Pressed;

   ------------------------
   -- On_Saispas_Pressed --
   ------------------------

   procedure On_Saispas_Pressed (
         Object : access Gtk_Button_Record'Class ) is 
   begin
      if La_Reponse = Attendue
            then
         La_Reponse := Non_Permise;
      else
         Suite_Reponse(Testada1.Textereponse);
         return;
      end if;
      Effacer(Testada1.Textereponse);
      Le_Vecteur(Num).Rep:='?';
      Ecrire (Testada1.Textereponse,
         "vous avez saisi je ne sais pas ! Le bon choix tait : "
         &Enreg.Reponse&"  voici pourquoi :");
      A_La_Ligne(Testada1.Textereponse);
      Repondre (Testada1.Textereponse,Enreg.Mauvaise);
   end On_Saispas_Pressed;

   ---------------------
   -- On_Faux_Pressed --
   ---------------------

   procedure On_Faux_Pressed (
         Object : access Gtk_Button_Record'Class ) is 
   begin
      if La_Reponse = Attendue
            then
         La_Reponse := Non_Permise;
      else
         Suite_Reponse(Testada1.Textereponse);
         return;
      end if;
      Effacer(Testada1.Textereponse);
      if Enreg.Reponse='F'
            then
         Le_Vecteur(Num).Rep:='B';
         Ecrire (Testada1.Textereponse,
            "Bien, vous avez saisi Faux et c'est cela :-) :-) "&
            " En effet :");
         A_La_Ligne(Testada1.Textereponse);
         Repondre(Testada1.Textereponse,Enreg.Bonne);
      else
         Le_Vecteur(Num).Rep:='M';
         Ecrire (Testada1.Textereponse,
            "Non, vous avez saisi Faux mais c'tait Vrai :-( :-( "&
            " En effet :");
         A_La_Ligne(Testada1.Textereponse);
         Repondre (Testada1.Textereponse,Enreg.Mauvaise);
      end if;
   end On_Faux_Pressed;

end Testada1_Pkg.Callbacks;
