-- fichier testada1_pkg-callbacks.ads
-- pour qcm machine graphique Testada
-- Guillaume Feneuille novembre 2000
-- dernire modif 20 02 01 (Juin DF)
-- version 1.3
--
with Ada.Strings.Bounded ;
use Ada.Strings.Bounded ;

with Ada.Direct_Io ;
with Ada.Text_Io;

with Ada.Calendar;
use Ada.Calendar;

package Testada1_Pkg.Callbacks is

   Max_Car : constant := 160; -- longueur maxi d'une ligne de texte   
   package P_Ligne is new Generic_Bounded_Length (Max_Car);
   use P_Ligne;

   type T_Reponse is 
         (Attendue,   -- attente d'une rponse
          Non_Permise); -- attente d'une question


   type T_Enreg is -- pour fichier direct "question"
      record 
         Question : Bounded_String;  
         -- texte question 
         Reponse : Character;      -- V, F ou ?                      
         Bonne   : Bounded_String;  
         -- texte pour bonne rponse         
         Mauvaise : Bounded_String;  
         -- texte pour rponse non bonne     
      end record; 

   Enreg : T_Enreg;  
   -- initialis par le bouton question 
   package P_Dir is new Ada.Direct_Io (T_Enreg);
   use P_Dir;

   subtype F_Dir is P_Dir.File_Type;

   subtype F_Text is Ada.Text_Io.File_Type;

   package P_Tex renames Ada.Text_Io;

   Fichier_Dir : F_Dir;  
   -- initialis par demarrage  partir du fichier des questions
   -- c'est l'image du fichier des questions
   La_Reponse : T_Reponse := Non_Permise;  
   -- attente question        
   subtype T_Question is Natural range 0 .. 20;
   -- 20 questions

   Nb_Question : T_Question := 0;  

   type Alea is 
      record 
         Fait : Boolean   := False;  
         Rep  : Character := ' ';  
      end record; 

   type Vect_Alea is array (Positive range <>) of Alea; 

   Num : Positive;  
   -- initialis par Tirage 
   Le_Vecteur : Vect_Alea (1 .. T_Question'Last);  

   -- pour rponses 
   Partir : Boolean := False;  
   -- autorisation de Quitter

   Top_Deb, Top_Fin : Time;
   -- pour prise de temps de l'exercice
   
   procedure On_Quitter_Pressed (
         Object : access Gtk_Button_Record'Class ); 

   procedure On_Suivante_Pressed (
         Object : access Gtk_Button_Record'Class ); 

   procedure On_Aide_Pressed (
         Object : access Gtk_Button_Record'Class ); 

   procedure On_Vrai_Pressed (
         Object : access Gtk_Button_Record'Class ); 

   procedure On_Saispas_Pressed (
         Object : access Gtk_Button_Record'Class ); 

   procedure On_Faux_Pressed (
         Object : access Gtk_Button_Record'Class ); 

end Testada1_Pkg.Callbacks;
